#include <stdlib.h>
#include <qtimer.h>
#include <time.h>
#include <math.h>

#include <GL/glut.h>
#include <GL/gl.h>

#include "GLCanvas.h"

void GLCanvas::initializeGL()
{
    glClear(GL_DEPTH_BUFFER_BIT | GL_COLOR_BUFFER_BIT);
    glClearColor(0.0f, 0.0f, 0.0f, 0.0f);

    // automatic buffer swapping
    setAutoBufferSwap(TRUE);
}

void GLCanvas::init()
{
}

/**
 * Handles resizing of window
 */
void GLCanvas::resizeGL(const int w, const int h)
{
    glViewport(0,0,w,h);
}

// draw stuff
void GLCanvas::paintGL()
{
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
    glMatrixMode(GL_MODELVIEW);
    glLoadIdentity();

    glColor3f(1,1,1);
    glBegin(GL_POINTS);
        glVertex3f(-1,0,-1);
        glVertex3f(-1,0,0);
        glVertex3f(-1,0,1);
        glVertex3f(0,0,1);
        glVertex3f(1,0,1);
        glVertex3f(1,0,-1);
   glEnd();

   glFlush();
}


void GLCanvas::mouseReleaseEvent(QMouseEvent * evt)
{
}

void GLCanvas::mouseDoubleClickEvent(QMouseEvent * evt)
{
    int x=evt->x();
    int y=evt->y();
}

void GLCanvas::mousePressEvent(QMouseEvent * evt)
{
    int x=evt->x();
    int y=evt->y();
}

// Mouse event handler
void GLCanvas::mouseMoveEvent(QMouseEvent * evt)
{
    int x=evt->x();
    int y=evt->y();
}

// Key event handler
void GLCanvas::keyReleaseEvent(QKeyEvent * evt)
{
}

// Key event handler
void GLCanvas::keyPressEvent(QKeyEvent * evt)
{
    int key=evt->key();
    switch (key)
    {
        case Qt::Key_Delete:
            break;
        case Qt::Key_P:
            break;
        case Qt::Key_W:
            break;
        case Qt::Key_Up:
            break;
        case Qt::Key_Down:
            break;
        case Qt::Key_Left:
            break;
        case Qt::Key_Right:
            break;
        case Qt::Key_Return:
            break;
    }
}

GLCanvas::~GLCanvas()
{
}

// Constructor
GLCanvas::GLCanvas(QWidget * parent) : QGLWidget(parent)
{
    // Animation timer
    paintTimer = new QTimer(this, "paintTimer");
    connect(paintTimer, SIGNAL(timeout()), this, SLOT(updateGL()));
    paintTimer->start(TIMER);

    setMouseTracking(true);
    setFocusPolicy(QWidget::StrongFocus);
}

// Example slot function
void GLCanvas::slot_setFlag()
{
    flag = true;
}
