#ifndef __GLCANVAS_H__
#define __GLCANVAS_H__

#define TIMER 25

#include <qgl.h>

class GLCanvas : public QGLWidget
{
    Q_OBJECT
    protected:
        virtual void initializeGL();
        virtual void resizeGL(const int width, const int height);
        virtual void paintGL();
        virtual void keyPressEvent(QKeyEvent * evt);
        virtual void keyReleaseEvent(QKeyEvent * evt);
        virtual void mouseMoveEvent(QMouseEvent * evt);
        virtual void mousePressEvent(QMouseEvent * evt);
        virtual void mouseDoubleClickEvent(QMouseEvent * evt);
        virtual void mouseReleaseEvent(QMouseEvent * evt);
        void init();

        // animation timer
        QTimer* paintTimer;

        // Some flag for demonstration purposes mate!
        bool flag;

    public:
        GLCanvas(QWidget * parent);
        virtual ~GLCanvas();

        public slots:
            void slot_setFlag();
};

#endif
