#include <qapplication.h>
#include <qmessagebox.h>
#include <qlayout.h>
#include <qmenubar.h>
#include <qpopupmenu.h>

#include "Window.h"


Window::Window(QWidget* parent, const char* name )
  : QWidget(parent,name)
{
    QVBoxLayout *mainlayout = new QVBoxLayout(this,0,-1,"mainlayout");
    

    glCanvas = new GLCanvas( this); //this-> its parent which is the main window "GLCanvas"-> its name
    mainlayout->addWidget( glCanvas ); // add it to the layout
    mainlayout->setStretchFactor( glCanvas, 1 ); // tell it to stretch when possible to fill the window

    // Project Caption
    setCaption("Caption on Title Bar");

    // This is a popup menu, the "File" menu
    QPopupMenu* fileMenu = new QPopupMenu( this );
    // The hot key is the letter "a"
    // event handler for this signal is in glcanvas
    fileMenu->insertItem("&Set some flag in glcanvas", glCanvas, SLOT(slot_setFlag()), Key_A);
    fileMenu->insertItem("&Quit", qApp, SLOT(quit()), CTRL+Key_Q);

    QPopupMenu* helpMenu = new QPopupMenu( this );
    // This is your project's about dialog
    helpMenu->insertItem("About Your Project", this, SLOT(about())); 
    // This is the QT about
    helpMenu->insertItem("&About Qt", qApp, SLOT(aboutQt()), CTRL+ Key_A); 

    // menubar
    QMenuBar* menubar = new QMenuBar( this );

    // add other menus to the menubar
    menubar->insertItem( "&File", fileMenu );
    menubar->insertSeparator();
    menubar->insertItem( "&Help", helpMenu );

    mainlayout->setMenuBar( menubar );

    setMinimumSize(300, 300);
}

void Window::about()
{
    QMessageBox::about(this, "About Your Project", "<br>This is HTML, so edit it as you wish!<br><br><i>&quot;Call me old fashioned but I like a dump to be as memorable as it is devastating.&quot;</i>");
}
